stages:
    - build
    - deploy

variables:
  IMAGE_REGISTRY_USER: $REPO_USER
  IMAGE_REGISTRY_PASS: $REPO_PASSWORD
  IMAGE_REGISTRY_PROJECT: $REPO_PROJECT
  IMAGE_REGISTRY_URL: $REPO_IMAGE_REGISTRY_URL$REPO_PROJECT

  IMAGE_TAG: $CI_COMMIT_SHORT_SHA.$CI_PIPELINE_IID
  PROJECT_NAME: $CI_PROJECT_NAME
  IMAGE_NAME_TAG: $CI_COMMIT_BRANCH.$IMAGE_TAG

  IMAGE_NAME_BUILD: $CI_PROJECT_NAME:$CI_COMMIT_BRANCH.$IMAGE_TAG
  IMAGE_NAME_BUILD_LATEST: $CI_PROJECT_NAME:$CI_COMMIT_BRANCH.latest
  # RUNNER_TAG: dev

build gke:
  when: manual
  stage: build
  tags:
    - gke1
  # when: manual
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  before_script:
    # - echo $IMAGE_REGISTRY_URL
    - echo $IMAGE_REGISTRY_USER
    # - echo $IMAGE_REGISTRY_PASS
    - echo "{\"auths\":{\"$IMAGE_REGISTRY_URL\":{\"auth\":\"$(printf "%s:%s" "$IMAGE_REGISTRY_USER" "$IMAGE_REGISTRY_PASS" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    # - cat /kaniko/.docker/config.json
  script:
    - echo $IMAGE_NAME_BUILD
    - echo $IMAGE_NAME_BUILD_LATEST
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --cache=true
      --destination "$IMAGE_REGISTRY_URL/$IMAGE_NAME_BUILD_LATEST"
      
deploy-gke:
    stage: deploy
    tags:
      - gke1
    # only: 
    #     - main
    image: alpine/k8s:1.23.16
    when: manual
    script: |
      sh k8s-deployment/deploy-gke.sh

deploy-gke2:
    stage: deploy
    tags:
      - gke2
    # only: 
    #     - main
    image: alpine/k8s:1.23.16
    when: manual
    script: |
      sh k8s-deployment/deploy-gke.sh
